<?php

// Management page for category order plugin

class category_order_shared {

// Returns a hash from slugs to associated category objects
function get_category_lookup() {
	global $wpdb;

	$categories =
		$wpdb->get_results("SELECT * FROM $wpdb->categories ORDER BY cat_name");

 	$category_lookup = array();

	foreach ($categories as $category)
		$category_lookup[$category->category_nicename] = $category;

	return $category_lookup;
}

// --------------------------------------------------------------------

/*
Get the user-specified category order from the database. Also update it
according to any new or deleted categories in the database.
*/
function get_category_order($ignore_prior_ordering=false) {
	$serialized_category_order = get_option('Category_Order');

	if ($serialized_category_order == false || $ignore_prior_ordering)
		$category_order = array();
	else
		eval("\$category_order = $serialized_category_order;");

	$category_lookup = category_order_shared::get_category_lookup();

	// Remove any references to unknown categories, except for ''
	for ($i=0; $i < count($category_order); $i++) {
		if ($category_order[$i][0] == '')
			continue;

		if ( !array_key_exists($category_order[$i][0], $category_lookup) ) {
			array_splice($category_order,$i,1);
			$i--;
		}
	}

	// Add unreferenced categories to the end of the top level
	foreach (array_keys($category_lookup) as $category_slug) {
		$found = 0;

		for ($i=0; $i < count($category_order); $i++)
			if ($category_order[$i][0] == $category_slug) {
				$found = 1;
				break;
			}

		if (!$found)
			array_push($category_order,array($category_slug,0));
	}

	return $category_order;
}

// --------------------------------------------------------------------

}

?>
